Package ec.parsimony

# Class RatioBucketTournamentSelection

java.lang.Object
ec.BreedingSource
ec.SelectionMethod
ec.parsimony.RatioBucketTournamentSelection

All Implemented Interfaces:
  `Prototype`, `Setup`, `SteadyStateBSourceForm`, `RandomChoiceChooserD`, `Serializable`, `Cloneable`

public class RatioBucketTournamentSelection extends SelectionMethod implements SteadyStateBSourceForm
Does a tournament selection, limited to the subpopulation it's working in at the time.

Ratio Bucket Lexicographic Tournament selection works like as follows. The sizes of buckets are proportioned so that low-fitness individuals are placed into much larger buckets than high-fitness individuals. A bucket ratio 1/ratio is specified beforehand. The bottom 1/ratio individuals of the population are placed into the bottom bucket. If any individuals remain in the population with the same fitness as the best individual in the bottom bucket, they too are placed in that bucket. Of the remaining population, the next 1/ratio individuals are placed into the next bucket, plus any individuals remaining in the population with the same fitness as the best individual now in that bucket, and so on. This continues until every member of the population has been placed in a bucket. Once again, the fitness of every individual in a bucket is set to the rank of the bucket relative to other buckets. Ratio bucketing thus allows parsimony to have more of an effect on average when two similar low-fitness individuals are considered than when two high-fitness individuals are considered. After ranking the individuals, size individuals are chosen at random from the population. Of those individuals, the one with the highest rank is selected. If the two individuals are in the same rank, meaning that they have similar fitness, the one with the smallest size is selected.

Bucket Lexicographic Tournament selection is so simple that it doesn't need to maintain a cache of any form, so many of the SelectionMethod methods just don't do anything at all.

Typical Number of Individuals Produced Per `produce(...)` call
Always 1.

Parameters

base.`size` int >= 1 (default 7) | (the tournament size)
base.`pick-worst` bool = `true` or `false` (default) | (should we pick the worst individual in the tournament instead of the best?)
base.`ratio` double >= 2 (default) | (the ratio of worst out of remaining individuals that go in the next bucket)

Default Base
select.ratio-bucket-tournament

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `P_PICKWORST`
  if the worst individual should be picked in the tournament
  `static final String`
  `P_RATIO`
  The value of RATIO: each step, the worse 1/RATIO individuals are assigned the same fitness
  `static final String`
  `P_RATIO_BUCKET_TOURNAMENT`
  default base
  `static final String`
  `P_SIZE`
  size parameter
  `boolean`
  `pickWorst`
  Do we pick the worst instead of the best?
  `double`
  `ratio`
  The value of RATIO
  `int`
  `size`
  Size of the tournament

  ### Fields inherited from class ec.SelectionMethod

  `INDS_PRODUCED, KEY_PARENTS`

  ### Fields inherited from class ec.BreedingSource

  `NO_PROBABILITY, P_PROB, probability`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `RatioBucketTournamentSelection()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Parameter`
  `defaultBase()`
  Returns the default base for this prototype.
  `void`
  `individualReplaced(SteadyStateEvolutionState state, int subpopulation, int thread, int individual)`
  Called whenever an individual has been replaced by another in the population.
  `void`
  `prepareToProduce(EvolutionState state, int subpopulation, int thread)`
  Prepare to produce: create the buckets!!!!
  `int`
  `produce(int subpopulation, EvolutionState state, int thread)`
  An alternative form of "produce" special to Selection Methods; selects an individual from the given subpopulation and returns its position in that subpopulation.
  `void`
  `setup(EvolutionState state, Parameter base)`
  Sets up the BreedingPipeline.
  `void`
  `sourcesAreProperForm(SteadyStateEvolutionState state)`
  Issue an error (not a fatal -- we guarantee that callers of this method will also call exitIfErrors) if any of your sources, or their sources, etc., are not of SteadyStateBSourceForm.

  ### Methods inherited from class ec.SelectionMethod

  `finishProducing, produce, produces, produceWithoutCloning, typicalIndsProduced`

  ### Methods inherited from class ec.BreedingSource

  `clone, fillStubs, getProbability, pickRandom, preparePipeline, setProbability, setupProbabilities`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### P_RATIO_BUCKET_TOURNAMENT

    public static final String P_RATIO_BUCKET_TOURNAMENT
    default base
    See Also:
      - Constant Field Values

  - ### P_SIZE

    public static final String P_SIZE
    size parameter
    See Also:
      - Constant Field Values

  - ### size

    public int size
    Size of the tournament

  - ### P_PICKWORST

    public static final String P_PICKWORST
    if the worst individual should be picked in the tournament
    See Also:
      - Constant Field Values

  - ### pickWorst

    public boolean pickWorst
    Do we pick the worst instead of the best?

  - ### P_RATIO

    public static final String P_RATIO
    The value of RATIO: each step, the worse 1/RATIO individuals are assigned the same fitness
    See Also:
      - Constant Field Values

  - ### ratio

    public double ratio
    The value of RATIO

- ## Constructor Details

  - ### RatioBucketTournamentSelection

    public RatioBucketTournamentSelection()

- ## Method Details

  - ### defaultBase

    public Parameter defaultBase()
    Description copied from interface: `Prototype`
    Returns the default base for this prototype. This should generally be implemented by building off of the static base() method on the DefaultsForm object for the prototype's package. This should be callable during setup(...).
    Specified by:
      `defaultBase` in interface `Prototype`

  - ### setup

    public void setup(EvolutionState state, Parameter base)
    Description copied from class: `BreedingSource`
    Sets up the BreedingPipeline. You can use state.output.error here because the top-level caller promises to call exitIfErrors() after calling setup. Note that probability might get modified again by an external source if it doesn't normalize right.

    The most common modification is to normalize it with some other set of probabilities, then set all of them up in increasing summation; this allows the use of the fast static BreedingSource-picking utility method, BreedingSource.pickRandom(...). In order to use this method, for example, if four breeding source probabilities are {0.3, 0.2, 0.1, 0.4}, then they should get normalized and summed by the outside owners as: {0.3, 0.5, 0.6, 1.0}.

    Specified by:
      `setup` in interface `Prototype`
    Specified by:
      `setup` in interface `Setup`
    Overrides:
      `setup` in class `BreedingSource`
    See Also:
      - `Prototype.setup(EvolutionState,Parameter)`

  - ### prepareToProduce

    public void prepareToProduce(EvolutionState state, int subpopulation, int thread)
    Prepare to produce: create the buckets!!!!
    Overrides:
      `prepareToProduce` in class `SelectionMethod`

  - ### produce

    public int produce(int subpopulation, EvolutionState state, int thread)
    Description copied from class: `SelectionMethod`
    An alternative form of "produce" special to Selection Methods; selects an individual from the given subpopulation and returns its position in that subpopulation.
    Specified by:
      `produce` in class `SelectionMethod`

  - ### individualReplaced

    public void individualReplaced(SteadyStateEvolutionState state, int subpopulation, int thread, int individual)
    Description copied from interface: `SteadyStateBSourceForm`
    Called whenever an individual has been replaced by another in the population.
    Specified by:
      `individualReplaced` in interface `SteadyStateBSourceForm`

  - ### sourcesAreProperForm

    public void sourcesAreProperForm(SteadyStateEvolutionState state)
    Description copied from interface: `SteadyStateBSourceForm`
    Issue an error (not a fatal -- we guarantee that callers of this method will also call exitIfErrors) if any of your sources, or their sources, etc., are not of SteadyStateBSourceForm.
    Specified by:
      `sourcesAreProperForm` in interface `SteadyStateBSourceForm`